<template>
  <div>
    <q-btn  style="margin-top:30px; margin-left: 30px" color="orange" icon="arrow_back" label="Kembali"
            to="/kategori" />
    <div class="q-pa-md" style="width: 80%; background: #4caf50; color: white; margin-top: 30px; margin-left: auto; margin-right: auto; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #4caf50">
      <h6 style="margin: 0px">Tambah Kategori</h6>
    </div>
    <q-form
      @submit="submitKategori"
    >
    <div class="q-pa-md" style="width: 80%; padding: 0; margin: auto; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #4caf50">
      <div>
        <p>&nbsp;</p>
        <h6 style="margin-left: 70px; margin-top: 0px; margin-bottom: 10px">Data Kategori</h6>
        <div class="q-gutter-y-md" style="width: 85%; margin: auto" >
          <q-select standout="bg-green text-white" v-model="parent" :options="optionsParent" ref="inputParent" @input="resetInputParent" label="Modul" />
          <q-input standout="bg-green text-white"  v-model="form.category" label="Nama Kategori" :rules="[val => !!val || 'Tolong Masukan Kategori']"/>
          <q-input standout="bg-green text-white" v-model="form.category_desc" label="Deskripsi Kategori" type="textarea" />
          <div class="row">
            <p style="font-size: 18px; margin-right: 50px">Web Logo</p>
            <q-file filled bottom-slots v-model="form.img_web" counter accept="image/*">
              <template v-slot:prepend>
                <q-icon name="cloud_upload" @click.stop />
              </template>
            </q-file>
          </div>
          <div class="row">
            <p style="font-size: 18px; margin-right: 30px">Mobile Logo</p>
            <q-file filled bottom-slots v-model="form.img_mobile" counter accept="image/*">
              <template v-slot:prepend>
                <q-icon name="cloud_upload" @click.stop />
              </template>
            </q-file>
          </div>
          <li style="margin-top: 5px">Format gambar yang di izinkan adalah .jpg, jpeg, & .png</li>
          <li style="margin-top: 5px">Max Ukuran Gambar adalah 1.5 MB</li>
        </div>
        <p>&nbsp;</p>
      </div>
    </div>
    <div style="margin-top: 20px; margin-left: auto; margin-right:auto; margin-bottom: 50px; width: 80%">
      <q-btn  label="Simpan Kategori" type="submit" color="green"/>
    </div>
    <p>&nbsp;</p>
    </q-form>
  </div>
</template>

<script>
  export default {
    name: "Category",

    data() {
      return {
        optionsParent: null,
        parent: null,
        form: {
          parent_id: null,
          category  : null,
          category_desc  : null,
          img_web  : null,
          img_mobile  : null,
        }
      }
    },

    beforeMount() {
      this.getListParent()
    },

    methods: {
      async submitKategori() {
        let accept = true;

        if (accept !== true) {
          this.$q.notify({
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            message: 'Mohon Periksa Kembali Form Anda'
          })
        }
        else {
          this.$q.loading.show()
          var data = new FormData();
          data.append('parent_id', this.parent.value);
          data.append('category', this.form.category);
          data.append('category_desc', this.form.category_desc);
          data.append('img_web', this.form.img_web);
          data.append('img_mobile', this.form.img_mobile);

          let dataApi = {
            method: "POST",
            url: "api/category/create",
            data: data,
            headers: {
              Authorization: "Bearer " + localStorage.getItem("token")
            }
          }



          this.$axios(dataApi)
          .then(sukses => {
            this.$router.push("/kategori")
            this.$q.notify({
              color: 'green-4',
              position: "top",
              textColor: 'white',
              icon: 'cloud_done',
              message: 'Berhasil Menambahkan Kategori'
            })
          })
          .catch(sukses => {})
          .then(selalu => {
            this.$q.loading.hide()
          })
        }
      },

      resetInputParent() {
        this.$refs.inputParent.resetValidation();
      },

      async getListParent() {
        let dataApi = {
          methods: "GET",
          url: "api/product-type/list/select",
          headers: {
            Authorization: "Bearer " + localStorage.getItem("token")
          }
        }
        this.$q.loading.show()
        await this.$axios(dataApi)
          .then(sukses => {
            this.optionsParent = sukses.data

          })
          .catch(gagal => {})
          .then(selalu => {
            this.$q.loading.hide()
          })
      }
    }
  }
</script>

<style scoped>

</style>
